/* this code is an nt-mode addition to the isdn4linux
   it will provide bchannel functions including audio patterns */

#include "hisax.h"
#include "isdnl1.h"
#include "linux/timer.h"

extern struct IsdnCard cards[];
extern int nrcards;
extern int init_b_st(struct Channel *chanp, int incoming);
extern void l3dss1_nt_bc_release(struct l3_process *pc, u_char pr, void *arg);

//#define TONE_DEBUG
//#define MINOR_DEBUG

//#define ECHOTEST

/* request bchannel:
cs= pointer to card state
channel= 1,2= gimme channel 1 or 2  all others= gimme any channel
returns channel # or -1 if not available
*/
//int test=0;
int bchannel_nt_alloc(struct IsdnCardState *cs,int channel) 
{
	int i;

	i=0;
	while(i<2) {
		if (cs->bchannel_nt[i].use==BCH_NT_USE_FREE) {
			if (channel==1 || channel==2) {
				if (i+1 == channel) {
					cs->bchannel_nt[i].use=BCH_NT_USE_INUSE;
#ifdef MINOR_DEBUG
					debugl1(cs,"bchannel_nt_alloc(): assigning requested channel %d",channel);
#endif
					cs->bchannel_nt[i].block_tones = 1;
					return(channel);
				}
			} else {
				cs->bchannel_nt[i].use=BCH_NT_USE_INUSE;
#ifdef MINOR_DEBUG
				debugl1(cs,"bchannel_nt_alloc(): assigning channel %d",i+1);
#endif
				cs->bchannel_nt[i].block_tones = 1;
				return(i+1);
			}
		}
		i++;
	}
#ifdef MINOR_DEBUG
	debugl1(cs,"bchannel_nt_alloc(): no channel available");
#endif
	return(-1);
}

void bchannel_nt_allow_tones(struct IsdnCardState *cs,int channel) 
{
	if (channel==1 || channel==2) {
		if (cs->bchannel_nt[channel-1].use==BCH_NT_USE_INUSE) {
#ifdef MINOR_DEBUG
			debugl1(cs,"bchannel_nt_allow_tones(): assigning requested channel %d",channel);
#endif
			cs->bchannel_nt[channel-1].block_tones = 0;
		} else {
#ifdef MINOR_DEBUG
			debugl1(cs,"bchannel_nt_allow_tones(): bchannel %d not in use",channel);
#endif
		}
	} else {
#ifdef MINOR_DEBUG
		debugl1(cs,"bchannel_nt_allow_tones(): wrong bchannel %d",channel);
#endif
	}
}

/* free channel
cs= pointer to card state
channel= 1,2= free channel 1 or 2
*/
void bchannel_nt_free(struct IsdnCardState *cs,int channel) 
{
#ifdef MINOR_DEBUG
	debugl1(cs,"bchannel_nt_free(): freeing channel %d",channel);
#endif
	if (channel>=1 && channel<=2 && cs->bchannel_nt[channel-1].use==BCH_NT_USE_INUSE) {
		if (cs->bchannel_nt[channel-1].tone != BCH_NT_TONE_NONE) {
			printk(KERN_WARNING "bchannel_nt_free(): bchannel %d still has a tone assigned! not removing... PLEASE FIX THIS BUG.\n",channel);
			return;
		}
		cs->bchannel_nt[channel-1].use=BCH_NT_USE_FREE;
	} else {
		printk(KERN_WARNING "bchannel_nt_free(): channel %d out of range!\n",channel);
	}

}

/***** tones *****/

/* all tones are alaw encoded */

unsigned char sample_german_all[]= {
	0x80,0xab,0x81,0x6d,0xfd,0xdd,0x5d,0x9d,
	0x4d,0xd1,0x89,0x88,0xd0,0x4c,0x9c,0x5c,
	0xdc,0xfc,0x6c,
};
unsigned char sample_american_dialtone[]= {
	0x2a,0xd0,0x9c,0x64,0x44,0xb4,0x44,0x64,0x9c,0xac,
	0x9e,0xb1,0xbd,0x25,0x85,0x05,0x85,0x25,0x3d,0x11,
	0x47,0x20,0xec,0x3c,0x1c,0xdc,0x1c,0xbc,0xec,0x00,
	0xc6,0x29,0x81,0x91,0xad,0x51,0x91,0x41,0xd9,0x29,
	0x6f,0x12,0x1e,0x7e,0xc2,0x13,0x07,0x57,0xe9,0xd7,
	0x1f,0x8e,0x08,0x80,0x90,0x2c,0x6c,0x6c,0x2c,0x30,
	0x48,0x5f,0x01,0x6d,0xfd,0x5d,0x25,0xa5,0x9d,0x0d,
	0x01,0xce,0x70,0x3c,0x24,0x84,0xc4,0x04,0xe4,0x7c,
	0x10,0xca,0x91,0x7d,0x65,0x45,0xb5,0x45,0x85,0xdd,
	0x2d,0x27,0xf0,0xfc,0x64,0xc4,0x44,0xc4,0x64,0x1c,
	0x2c,0x16,0x81,0xcd,0x5d,0x65,0x85,0x65,0xa5,0x3d,
	0xd1,0x29,0x38,0x50,0xcc,0xfc,0x7c,0xfc,0xcc,0x2c,
	0x80,0xf6,0xc7,0xd9,0xc1,0x31,0x31,0xc1,0x21,0x09,
	0xc7,0x33,0xba,0xba,0xb3,0x87,0xe9,0x39,0x19,0x19,
	0x49,0xb7,0x2e,0xb8,0x40,0xac,0x8c,0x4c,0xcc,0x8c,
	0xd0,0x58,0x13,0x01,0x8d,0x7d,0x25,0xe5,0xe5,0x5d,
	0x4d,0x31,0x7b,0x30,0x3c,0x24,0x04,0xc4,0xc4,0x64,
	0x1c,0x2c,0xe6,0x31,0xfd,0x65,0xc5,0xb5,0x45,0x05,
	0x5d,0x6d,0x29,0x00,0xbc,0xe4,0x04,0x44,0xc4,0x64,
	0xdc,0xec,0x08,0xd9,0x6d,0x9d,0x25,0x65,0xe5,0x5d,
	0xbd,0xd1,0x09,0xe8,0xf0,0x6c,0x4c,0xbc,0x4c,0x8c,
	0xd0,0x60,0x76,0xff,0xc9,0x21,0x61,0xe1,0x99,0x89,
	0x47,0xef,0x6b,0x6b,0xef,0xb7,0x09,0x59,0x81,0xc1,
	0x01,0x21,0xe9,0xa2,0xf8,0xf0,0x6c,0x4c,0xfc,0xfc,
	0x4c,0xec,0x80,0x1a,0x81,0x8d,0x1d,0xe5,0x65,0x65,
	0x25,0xfd,0xd1,0x27,0x40,0xbc,0x24,0x04,0x44,0x44,
	0x84,0x5c,0x6c,0x28,0x01,0xbd,0xe5,0xc5,0xb5,0xb5,
	0x05,0xa5,0x8d,0xb9,0x20,0xcc,0xa4,0x84,0xc4,0xc4,
	0x64,0xdc,0x6c,0x78,0xc9,0x2d,0xfd,0xa5,0x25,0x25,
	0xdd,0x4d,0xd1,0xb9,0xc6,0x00,0xac,0x8c,0x0c,0x8c,
	0x2c,0xf0,0x20,0x76,0xb3,0xd7,0xc9,0x49,0x89,0x97,
	0x9f,0x0b,0x72,0x12,0x8b,0x27,0x89,0x21,0x41,0x71,
	0x11,0x71,0xc1,0x39,0x7b,0xf8,0x90,0x0c,0xfc,0x9c,
	0x1c,0xfc,0x8c,0xb0,0x1e,0x61,0x8d,0x1d,0xe5,0x85,
	0x85,0xe5,0x9d,0x2d,0x29,0x80,0x4c,0x24,0x04,0x44,
	0x44,0x04,0xa4,0x0c,0x38,0x21,0x4d,0x25,0xc5,0xb5,
	0x45,0x05,0x25,0xcd,0x59,0x38,0x8c,0xdc,0x64,0x04,
	0x04,0x64,0xdc,0x8c,0x20,0x17,0x11,0x4d,0x1d,0xa5,
	0x5d,0x9d,0xcd,0x11,0xf9,0x4e,0x20,0x70,0x2c,0xec,
	0x2c,0x10,0xc0,0xf8,0x46,0xcb,0xe7,0xb7,0xc7,0xff,
	0x2a,0xfe,0xc6,0xb6,0xe6,0xca,0x47,0xf9,0xc1,0x11,
	0x2d,0xed,0x2d,0x71,0x21,0x4f,0xf8,0x10,0xcc,0x9c,
	0x5c,0xa4,0x1c,0x4c,0x10,0x16,0x21,0x8d,0xdd,0x65,
	0x05,0x05,0x65,0xdd,0x8d,0x39,0x58,0xcc,0x24,0x04,
	0x44,0xb4,0xc4,0x24,0x4c,0x20,0x39,0x0d,0xa5,0x05,
	0x45,0x45,0x05,0x25,0x4d,0x81,0x28,0x2c,0x9c,0xe4,
	0x84,0x84,0xe4,0x1c,0x8c,0x60,0x1f,0xb1,0x8d,0xfd,
	0x1d,0x9d,0xfd,0x0d,0x91,0xf9,0x7a,0x38,0xc0,0x70,
	0x10,0x70,0x40,0x20,0x88,0x26,0x8a,0x13,0x73,0x0a,
	0x9e,0x96,0x88,0x48,0xc8,0xd6,0xb2,0x77,0x21,0xf1,
	0x2d,0x8d,0x0d,0x8d,0xad,0x01,0xc7,0xb8,0xd0,0x4c,
	0xdc,0x24,0x24,0xa4,0xfc,0x2c,0xc8,0x79,0x6d,0xdd,
	0x65,0xc5,0xc5,0x85,0xa5,0xcd,0x21,0xb8,0x8c,0xa4,
	0x04,0xb4,0xb4,0xc4,0xe4,0xbc,0x00,0x29,0x6d,0x5d,
	0x85,0x45,0x45,0x05,0x25,0xbd,0x41,0x26,0xd0,0xfc,
	0x24,0x64,0x64,0xe4,0x1c,0x8c,0x80,0x1b,0x81,0xed,
	0x4d,0xfd,0xfd,0x4d,0x6d,0xf1,0xf9,0xa3,0xe8,0x20,
	0x00,0xc0,0x80,0x58,0x08,0xb6,0xee,0x6a,0x6a,0xee,
	0x46,0x88,0x98,0xe0,0x60,0x20,0xc8,0xfe,0x77,0x61,
	0xd1,0x8d,0x4d,0xbd,0x4d,0x6d,0xf1,0xe9,0x08,0xd0,
	0xbc,0x5c,0xe4,0x64,0x24,0x9c,0x6c,0xd8,0x09,0xed,
	0xdd,0x65,0xc5,0x45,0x05,0xe5,0xbd,0x01,0x28,0x6c,
	0x5c,0x04,0x44,0xb4,0xc4,0x64,0xfc,0x30,0xe7,0x2d,
	0x1d,0x65,0xc5,0xc5,0x05,0x25,0x3d,0x31,0x7a,0x30,
	0x4c,0x5c,0xe4,0xe4,0x24,0x7c,0x8c,0x00,0x12,0x59,
	0xd1,0x8d,0xcd,0x4d,0x8d,0xad,0x41,0xb9,0x2f,0xb6,
	0x48,0x18,0x18,0x38,0xe8,0x86,0xb2,0xbb,0xbb,0x32,
	0xc6,0x08,0x20,0xc0,0x30,0x30,0xc0,0xd8,0xc6,0xf7,
	0x81,0x2d,0xcd,0xfd,0x7d,0xfd,0xcd,0x51,0x39,0x28,
	0xd0,0x3c,0xa4,0x64,0x84,0x64,0x5c,0xcc,0x80,0x17,
	0x2d,0x1d,0x65,0xc5,0x45,0xc5,0x65,0xfd,0xf1,0x26,
	0x2c,0xdc,0x84,0x44,0xb4,0x44,0x64,0x7c,0x90,0xcb,
	0x11,0x7d,0xe5,0x05,0xc5,0x85,0x25,0x3d,0x71,0xcf,
	0x00,0x0c,0x9c,0xa4,0x24,0x5c,0xfc,0x6c,0x00,0x5e,
	0x49,0x31,0x2d,0x6d,0x6d,0x2d,0x91,0x81,0x09,0x8f,
	0x1e,0xd6,0xe8,0x56,0x06,0x12,0xc3,0x7f,0x1f,0x13,
	0x6e,0x28,0xd8,0x40,0x90,0x50,0xac,0x90,0x80,0x28,
	0xc7,0x01,0xed,0xbd,0x1d,0xdd,0x1d,0x3d,0xed,0x21,
	0x46,0x10,0x3c,0x24,0x84,0x04,0x84,0x24,0xbc,0xb0,
	0x9f,0xad,0x9d,0x65,0x45,0xb5,0x45,0x65,0x9d,0xd1,
};
unsigned char sample_american_ringing[]= {
	0x2a,0x42,0xee,0x2e,0x1a,0x73,0x87,0x29,0x49,0x79,
	0x79,0xc9,0xf7,0x0b,0x96,0x18,0x00,0xf0,0x70,0xb0,
	0xe0,0x28,0x3f,0xd9,0xf1,0x2d,0x6d,0x6d,0xad,0x01,
	0x77,0xe8,0x30,0x6c,0xbc,0x3c,0x4c,0x6c,0xc0,0x0e,
	0xe1,0xed,0x3d,0xdd,0xdd,0x7d,0x8d,0x81,0x26,0x90,
	0xbc,0x5c,0xe4,0x24,0x1c,0x6c,0x98,0xf9,0x8d,0xdd,
	0x65,0x85,0xe5,0x1d,0xed,0xf7,0xb0,0x3c,0xe4,0x04,
	0x04,0x64,0x9c,0x10,0xcf,0x2d,0x5d,0x85,0x45,0xc5,
	0x65,0x3d,0x01,0xf8,0x4c,0xe4,0xc4,0xb4,0xc4,0xe4,
	0xcc,0x08,0xb1,0x9d,0x85,0x45,0xb5,0x05,0xa5,0x2d,
	0x2a,0x2c,0xa4,0x04,0xb4,0x44,0x84,0x9c,0xb0,0x09,
	0xcd,0xe5,0xc5,0xb5,0xc5,0xe5,0x4d,0xf9,0x00,0x3c,
	0x64,0xc4,0x44,0x84,0x5c,0x2c,0xce,0x11,0x9d,0x65,
	0x05,0x05,0xe5,0x3d,0xb1,0xf6,0xec,0x1c,0xe4,0x84,
	0x64,0xdc,0x8c,0xf8,0x99,0x6d,0x1d,0x25,0xe5,0x5d,
	0xbd,0x91,0x27,0x80,0x8c,0x7c,0xdc,0xdc,0x3c,0xec,
	0xe0,0x0f,0xc1,0x6d,0x4d,0x3d,0xbd,0x6d,0x31,0xe9,
	0x76,0x00,0xac,0x6c,0x6c,0x2c,0xf0,0xd8,0x3e,0x29,
	0xe1,0xb1,0x71,0xf1,0x01,0x19,0x97,0x0a,0xf6,0xc8,
	0x78,0x78,0x48,0x28,0x86,0x72,0x1b,0x2f,0xef,0x43,
};
unsigned char sample_american_busy[]= {
	0x2a,0x67,0x77,0x27,0xfe,0x18,0x70,0xec,0x8c,0x2c,
	0x80,0x2f,0x71,0x3d,0xa5,0xe5,0xdd,0x6d,0x37,0x10,
	0xdc,0x04,0xc4,0x84,0x7c,0x60,0x41,0xdd,0xc5,0xb5,
	0xc5,0xa5,0x11,0xc8,0xbc,0x64,0xc4,0x04,0xa4,0x2c,
	0x2a,0x51,0x7d,0xa5,0x5d,0x3d,0x11,0xb7,0x98,0x10,
	0x2c,0xac,0xb0,0x78,0x5e,0xef,0x9f,0x7b,0xe6,0xe8,
	0x08,0x96,0x53,0xd9,0x11,0x8d,0xcd,0x8d,0x31,0xef,
	0xb0,0x3c,0x24,0xe4,0xa4,0xcc,0xf8,0xb1,0x1d,0x85,
	0x45,0x05,0x5d,0xf1,0xd8,0x7c,0x04,0xb4,0x44,0xe4,
	0xec,0x1f,0x0d,0xe5,0x05,0x05,0x25,0x6d,0xb7,0x30,
	0xbc,0xdc,0xdc,0x3c,0x50,0xe8,0x89,0xb1,0x11,0x91,
	0x01,0x49,0x1f,0x1a,0x1a,0x3f,0xe9,0x79,0x19,0x09,
	0x2a,0x18,0xd0,0xcc,0xbc,0xcc,0xd0,0x16,0x01,0xbd,
	0x25,0x65,0xe5,0xfd,0x81,0xe0,0xfc,0x84,0x44,0xc4,
	0x24,0x2c,0xd7,0xbd,0x85,0x45,0x45,0x65,0x0d,0x9f,
	0x2c,0xa4,0x84,0x84,0x24,0x0c,0x48,0x61,0x0d,0x9d,
	0x9d,0xbd,0x51,0x49,0xb6,0x60,0x30,0x40,0xe0,0x68,
	0x4e,0xeb,0xc2,0xf6,0xf8,0x60,0x80,0x98,0x0e,0x79,
	0x51,0x4d,0xfd,0x3d,0xed,0x39,0x20,0x4c,0x24,0x84,
	0x64,0x1c,0x70,0x09,0xbd,0x65,0x45,0x45,0xe5,0x8d,
	0x2a,0x8c,0xe4,0x44,0x44,0x64,0xbc,0x08,0x71,0x1d,
	0x65,0x85,0x25,0x4d,0x21,0x38,0xec,0x3c,0xfc,0x4c,
	0x50,0x78,0x0f,0x99,0x81,0x61,0xf9,0xf7,0xc3,0xea,
	0x4f,0x69,0xe1,0x41,0x31,0x61,0xb7,0x48,0x50,0xbc,
	0x9c,0x9c,0x0c,0x60,0x49,0x0d,0x25,0x85,0x85,0xa5,
	0x2d,0x9e,0x0c,0x64,0x44,0x44,0x84,0xbc,0xd6,0x2d,
	0x25,0xc5,0x45,0x85,0xfd,0xe1,0x80,0xfc,0xe4,0x64,
	0x24,0xbc,0x00,0x17,0xd1,0xcd,0xbd,0xcd,0xd1,0x19,
	0x2a,0x08,0x18,0x78,0xe8,0x3e,0x1b,0x1b,0x1e,0x48,
	0x00,0x90,0x10,0xb0,0x88,0xe9,0x51,0x3d,0xdd,0xdd,
	0xbd,0x31,0xb6,0x6c,0x24,0x04,0x04,0xe4,0x0c,0x1e,
	0xed,0xe5,0x45,0xb5,0x05,0x7d,0xd9,0xf0,0x5c,0x04,
	0x44,0x84,0x1c,0xb0,0xf9,0xcd,0xa5,0xe5,0x25,0x3d,
	0xb1,0xee,0x30,0x8c,0xcc,0x8c,0x10,0xd8,0x52,0x97,
	0x09,0xe9,0xe7,0x7a,0x9e,0xee,0x5f,0x79,0xb1,0xad,
	0x2d,0x11,0x99,0xb6,0x10,0x3c,0x5c,0xa4,0x7c,0x50,
	0x2a,0x2d,0xa5,0x05,0xc5,0x65,0xbd,0xc9,0x10,0xa4,
	0xc4,0xb4,0xc4,0xdc,0x40,0x61,0x7d,0x85,0xc5,0x05,
	0xdd,0x11,0x36,0x6c,0xdc,0xe4,0xa4,0x3c,0x70,0x2e,
	0x81,0x2d,0x8d,0xed,0x71,0x19,0xff,0x26,0x76,0x66,
};
unsigned char sample_silence[]= {
	0xa2,0xa2,0xa2,0xa2,0xa2,0xa2,0xa2,0xa2,
	0xa2,0xa2,0xa2,0xa2,0xa2,0xa2,0xa2,0xa2,
	0xa2,0xa2,0xa2,0xa2,0xa2,0xa2,0xa2,0xa2,
	0xa2,0xa2,0xa2,0xa2,0xa2,0xa2,0xa2,0xa2,
	0xa2,0xa2,0xa2,0xa2,0xa2,0xa2,0xa2,0xa2,
	0xa2,0xa2,0xa2,0xa2,0xa2,0xa2,0xa2,0xa2,
};

struct samples {
	int len;
	unsigned char *data;
	} samples[] = {
	{sizeof(sample_silence),		sample_silence},
	{sizeof(sample_german_all),		sample_german_all},
	{sizeof(sample_american_dialtone),	sample_american_dialtone},
	{sizeof(sample_american_ringing),	sample_american_ringing},
	{sizeof(sample_american_busy),		sample_american_busy},
};


#define TB_SIZE 512
unsigned char nt_tonebuffer[TB_SIZE];

/* copy tone to skb */
inline struct sk_buff
*copy_tone(struct IsdnCardState *cs, int tone,int *count,int len)
{
	struct sk_buff *skb;
	int i,spl,sample;
	int mark,space; /* mark is the length of tone and space the delay between the tones */

	switch(tone) {
		case BCH_NT_TONE_SILENCE:
		sample=0;
		mark=sizeof(sample_silence);
		space=0;
//sample=1; mark=400; space=500;
		break;
		case BCH_NT_TONE_DIALTONE:
		sample=(cs->nt.tones)?1:2;
		if (cs->nt.tones)
			mark=sizeof(sample_german_all);
		else	mark=sizeof(sample_american_dialtone);
		space=0;
		break;
		case BCH_NT_TONE_RINGING:
		sample=(cs->nt.tones)?1:3;
		mark=7999;
		space=32001;
		break;
		case BCH_NT_TONE_BUSY:
		sample=(cs->nt.tones)?1:4;
		mark=4009;
		space=3991;
		break;
		case BCH_NT_TONE_RELEASE:
		default:
		sample=(cs->nt.tones)?1:4;
		mark=(cs->nt.tones)?1995:4009;
		space=(cs->nt.tones)?2005:3991;
		break;
	}

	i=0;
	while(42)
	{
		/* check if size is reached or buffer is full */
		if (i==len || i==TB_SIZE)
			break;

		/* check if space is reached */
		if (*count < mark)
			spl=sample; /* tone */
		else	spl=0; /* silence */

		/* copy sample */
		nt_tonebuffer[i]=samples[spl].data[*count % samples[spl].len];
		(*count)++;
		i++;

		/* check loop arround of counter */
		if (*count >= mark+space)
			*count -= (mark+space);
	}

	/* alloc sk buffer */	
	if (!(skb = alloc_skb(len, GFP_ATOMIC)))
		return(0);

	/* copy tonebuffer to skbuffer and return */
	memcpy(skb_put(skb, len),nt_tonebuffer,len);
	return(skb);
}

#ifdef TONE_DEBUG
unsigned long debug_cycle=0;
#endif

/* handler for handling incomming data.
every time data is received, data will be sent.
this ensures that the buffer is filled with the same speed it is transmitted.
this is because received data is synchron to the transmitted data.
*/
static void
tones_handler (struct PStack *st, int pr, void *arg)
{
	struct sk_buff *skb = arg;//, *skb_s;
	struct BCState *bcs;
	struct IsdnCardState *cs;
	int bc;
	int tone;
	int len;

//	printk(KERN_WARNING "tones_handler(): event occured: %#x\n",pr);

	switch(pr) {
		case (PH_DATA | INDICATION):
		len=skb->len;

		cs=st->l1.hardware;
		bc=st->l1.bc;

#ifdef TONE_DEBUG
		debugl1(cs,"tones_handler(): PH_DATA len=%d",len);
#endif
		
		if (bc<0 || bc>1) {
			printk(KERN_WARNING "tones_handler(): illegal bchannel %d (0 or 1) of st->l1.bc\n",bc);
			return;
		}

		bcs=cs->bchannel_nt[bc].chan->bcs;

/*
bcs->tx_cnt=0;
while ((skb_s=skb_dequeue(&bcs->squeue))) {
#ifdef TONE_DEBUG
	debugl1(cs,"tones_handler(): data in squeue: %d",skb_s->len);
#endif
	dev_kfree_skb(skb_s);
}
*/
		tone=cs->bchannel_nt[bc].tone;
		if (tone == BCH_NT_TONE_NONE) {
#ifdef TONE_DEBUG
		debugl1(cs, "tones_handler() tone is off, but data is still receiving: len=%d",skb->len);
#endif
			dev_kfree_skb(skb);
			break;
		}

/*		if (cs->bchannel_nt[bc].flush > 0) {
			cs->bchannel_nt[bc].flush -= len;
			dev_kfree_skb(skb);
			break;
		}
*/
#ifdef ECHOTEST
		bcs->tx_cnt += skb->len;
		st->l2.l2l1(st, PH_DATA | REQUEST, skb);
#ifdef TONE_DEBUG
		debugl1(cs,"tones_handler(): %d bytes to be echo",len);
#endif
#else
		dev_kfree_skb(skb);

		bcs=cs->bchannel_nt[bc].chan->bcs;
#ifdef TONE_DEBUG
		debugl1(cs,"tones_handler(): %d bytes to be sent",len);
#endif
		if ((skb = copy_tone(cs, tone, &(cs->bchannel_nt[bc].count), len)))
		{
			bcs->tx_cnt += skb->len;
			st->l2.l2l1(st, PH_DATA | REQUEST, skb);
		}
#endif // ECHOTEST
		break;


		case (PH_DEACTIVATE | INDICATION):
		case (PH_DEACTIVATE | CONFIRM):

		cs=st->l1.hardware;
		bc=st->l1.bc;

#ifdef TONE_DEBUG
		debugl1(cs,"tones_handler(): PH_DEACTIVATE len=%d",len);
#endif
		
		if (bc<0 || bc>1) {
			printk(KERN_WARNING "tones_handler(): illegal bchannel %d (0 or 1) of st->l1.bc\n",bc);
			return;
		}

		//l3dss1_nt_bc_release(cs->bchannel_nt[bc].pc,0,NULL);

/*
bcs->tx_cnt=0;
while ((skb_s=skb_dequeue(&bcs->squeue))) {
#ifdef TONE_DEBUG
	debugl1(cs,"tones_handler(): data in squeue: %d",skb_s->len);
#endif
	dev_kfree_skb(skb_s);
}
*/
		tone=cs->bchannel_nt[bc].tone;
		break;
	}
}


/* initialize tones capability 
*/
void tones_nt_alloc(void)
{
#ifdef TONE_DEBUG
	printk(KERN_WARNING "tones_nt_alloc(): allocating tone capability\n");
#endif
}


/* frees tones capability 
*/
void tones_nt_free(void) 
{
	int i,j;
//	struct PStack *st;
	//struct Channel *chan;

	/* check all cards */
	i=0;
	while(i<nrcards) { /* loop all cards */
		if (cards[i].cs)
		if (cards[i].protocol == ISDN_PTYPE_EURO_NT) {
			j=0;
			while(j<2) { /* loop all bchannels */
				if (cards[i].cs->bchannel_nt[j].tone != BCH_NT_TONE_NONE) {
					printk(KERN_WARNING "there are still tones enabled\n");
#ifdef TONE_DEBUG
//					debugl1(cards[i].cs,"tones_nt_free(): release card %d channel %d",i,j);
#endif
					
//					chan=cards[i].cs->bchannel_nt[j].chan;
//					chan->b_st->lli.l4l3(chan->b_st, DL_RELEASE | REQUEST, NULL);
				}
				j++;
			}
		}
		i++;
	}
}


/* set tone of given bchannel
cs= pointer to card state
bchannel= 1 or 2 for bchannel to send the tone
tone= name of tone to use, (-1) for stopping tone
*/
void tones_nt_set(struct l3_process *pc, int tone) {
	struct Channel *chan; /* channel structure */
	int bchannel; /* bchannel number (1 or 2) */
	struct IsdnCardState *csta; /* the used card */
	struct bchannel_nt *bch_nt; /* bchannel_nt structure */
	struct sk_buff *skb;

	chan = pc->chan; /* channel structure */
	csta = pc->st->l1.hardware; /* the used card */
	if (!chan) {
		printk(KERN_WARNING "tones_nt_set(): no channel structure found at process!!!\n");
		return;
	}
	bchannel = pc->para.bchannel; /* bchannel number (1 or 2) */
	if (bchannel<1 || bchannel>2) {
		printk(KERN_WARNING "tones_nt_set(): illegal bchannel %d\n",bchannel);
		return;
	}
	bch_nt = &csta->bchannel_nt[bchannel-1]; /* bchannel_nt structure */

	if (bch_nt->block_tones) { /* if tones are not allowed */
#ifdef MINOR_DEBUG
		debugl1(csta,"tones_nt_set(): tones of bchannel %d are blocked.",bchannel);
#endif
		return;
	}
#ifdef MINOR_DEBUG
	debugl1(csta,"tones_nt_set(): setting state of bchannel %d with %d tone",bchannel,tone);
#endif
#ifdef TONE_DEBUG
	debugl1(csta,"tones_nt_set(): setting state of bchannel %d with %d tone",bchannel,tone);
#endif

	if (bch_nt->use != BCH_NT_USE_INUSE) {
		debugl1(csta,"tones_nt_set(): bchannel %d not in use, so there will be no tone!",bchannel);
		return;
	}

	if (tone != BCH_NT_TONE_NONE) { /* set tone */
		bch_nt->chan=chan; /* channel pointer */
		bch_nt->count=0; /* start off from the beginning */
		if (tone == BCH_NT_TONE_RELEASE)
			bch_nt->count=2000; /* 1/4 s before first rel. tone */
		if (tone == BCH_NT_TONE_BUSY)
			bch_nt->count=6000; /* 1/4 s before first busy tone */
		if (tone == BCH_NT_TONE_RINGING)
			bch_nt->count=38000; /* 1/4 s before first ringing */

		/* no tone before ?? */
		if (bch_nt->tone == BCH_NT_TONE_NONE)
		{
#ifdef TONE_DEBUG
			debugl1(csta,"tones_nt_set(): activating bchannel %d",bchannel);
#endif
			/* enable bchannel */
			chan->l2_active_protocol=ISDN_PROTO_L2_TRANS;
			chan->incoming = !0;
			//chan->cs->cardmsg(chan->cs, MDL_INFO_SETUP, (void *) (long)chan->chan);
			init_b_st(chan,0);
			chan->b_st->l1.l1l2 = tones_handler; /* tones will be handled there*/
			bch_nt->pc = pc;

#ifdef MINOR_DEBUG
			debugl1(csta,"tones_nt_set(): data in tx_cnt: %d", chan->bcs->tx_cnt);
#endif
			chan->bcs->tx_cnt = 0;
			while ((skb=skb_dequeue(&chan->bcs->squeue))) {
#ifdef MINOR_DEBUG
				debugl1(csta,"tones_nt_set(): data in squeue: %d",skb->len);
#endif
				dev_kfree_skb(skb);
			}

			chan->b_st->lli.l4l3(chan->b_st, DL_ESTABLISH | REQUEST, NULL);
			/* fill tx buffer with some extra data to compensate buffer underun */
			if ((skb = copy_tone(csta, tone, &(bch_nt->count), 512)))
			{
				chan->bcs->tx_cnt += skb->len;
				chan->b_st->l2.l2l1(chan->b_st, PH_DATA | REQUEST, skb);
			}
		}

		/* set tone */
		bch_nt->tone = tone;

	} else { /* stop tone */
		if (bch_nt->tone != BCH_NT_TONE_NONE)
		{	
#ifdef TONE_DEBUG
			debugl1(csta,"tones_nt_set(): deactivating bchannel %d",bchannel);
#endif
			/* deactivating bchannel */
			chan->b_st->lli.l4l3(chan->b_st, DL_RELEASE | REQUEST, NULL);
			//chan->cs->cardmsg(chan->cs, MDL_INFO_REL, (void *) (long)chan->chan);

			bch_nt->tone=BCH_NT_TONE_NONE;
#ifdef MINOR_DEBUG
			debugl1(csta,"tones_nt_set(): data in tx_cnt: %d",chan->bcs->tx_cnt);
#endif
			chan->bcs->tx_cnt=0;
			while ((skb=skb_dequeue(&chan->bcs->squeue))) {
#ifdef MINOR_DEBUG
				debugl1(csta,"tones_nt_set(): data in squeue: %d",skb->len);
#endif
				dev_kfree_skb(skb);
			}
		} else {
			return; /* no tone specified */
		}
	}
}

