/* $Id: isdn_tty.h,v 0.0.0.1 2002/00/00 00:00:00 jolly Exp $
 *
 * header for Linux ISDN subsystem, isdnraw related functions (linklevel).
 *
 * Copyright 2002 	by Andreas Eversberg (isdn@jolly.de)
 *
 * This software may be used and distributed according to the terms
 * of the GNU General Public License, incorporated herein by reference.
 *
 */

#include <linux/config.h>

extern int isdn_raw_init(void);
extern void isdn_raw_cleanup(void);
extern int isdn_raw_find_icall(int, isdn_ctrl *);
extern int isdn_raw_stat_callback(int, isdn_ctrl *);
extern int isdn_raw_rcv_skb(int, int, struct sk_buff *);
//extern int isdn_raw_capi_facility(capi_msg *cm); 

extern int isdn_raw_read(struct file *, char *, int);
extern int isdn_raw_write(struct file *, char *, int);
extern unsigned int isdn_raw_poll(struct file *, struct poll_table_struct *);
extern int isdn_raw_ioctl(struct file *, unsigned int, unsigned long);
extern int isdn_raw_open(struct file *);
extern void isdn_raw_close(struct file *);


#define ISDNRAW_MAXBUF	256		 /* maximum number of buffers */

#define ISDNRAW_DTMF_NPOINTS	102 //205 /* samples to decode */

/* receive buffer chain */
typedef struct isdnraw_rx_buffer {
  struct isdnraw_rx_buffer *next;	 /* next in chain */
  int			count;		 /* number of bytes */
  unsigned char		data[0];	 /* bytes */
} isdnraw_rx_buffer;


/* info */
typedef struct isdnraw_info {
  int			in_use;
  int                   isdn_driver;	 /* Index to isdn-driver           */
  int                   isdn_channel;    /* Index to isdn-channel          */
  int			drv_index;	 /* driver index */
  isdnraw_outfilter	outfilter;
  isdnraw_infilter	infilter;
  int			dsp;		 /* audio processing */
  int			conversion;	 /* audio conversion */
#ifdef CONFIG_ISDN_AUDIO
  void                  *adpcms;         /* state for adpcm decompression  */
  void                  *adpcmr;         /* state for adpcm compression    */
  signed short		dtmf_buffer[ISDNRAW_DTMF_NPOINTS]; /* sample buffer */
  int			dtmf_size;	 /* number of samples in buffer */
  unsigned char		dtmf_lastdigit;	 /* stores last dtmf-digit */
  unsigned char		dtmf_lastwhat;	 /* stores last detected tone */
  unsigned char		dtmf_count;	 /* count continues tone */
#endif
  /* buffers */
  isdnraw_rx_buffer	*rx_buffer;      /* start of receive buffer chain */
  isdnraw_rx_buffer	**rx_buffer_end; /* pointer to endpointer */
  int			rx_inbuf;	 /* number of data packets in buffer */
} isdnraw_info;

